# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class AccountCreate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, email: str=None, first_name: str='', last_name: str='', group_id: int=None, institution_user_id: str='', symplectic_user_id: str='', quota: int=None, is_active: bool=None):  # noqa: E501
        """AccountCreate - a model defined in Swagger

        :param email: The email of this AccountCreate.  # noqa: E501
        :type email: str
        :param first_name: The first_name of this AccountCreate.  # noqa: E501
        :type first_name: str
        :param last_name: The last_name of this AccountCreate.  # noqa: E501
        :type last_name: str
        :param group_id: The group_id of this AccountCreate.  # noqa: E501
        :type group_id: int
        :param institution_user_id: The institution_user_id of this AccountCreate.  # noqa: E501
        :type institution_user_id: str
        :param symplectic_user_id: The symplectic_user_id of this AccountCreate.  # noqa: E501
        :type symplectic_user_id: str
        :param quota: The quota of this AccountCreate.  # noqa: E501
        :type quota: int
        :param is_active: The is_active of this AccountCreate.  # noqa: E501
        :type is_active: bool
        """
        self.swagger_types = {
            'email': str,
            'first_name': str,
            'last_name': str,
            'group_id': int,
            'institution_user_id': str,
            'symplectic_user_id': str,
            'quota': int,
            'is_active': bool
        }

        self.attribute_map = {
            'email': 'email',
            'first_name': 'first_name',
            'last_name': 'last_name',
            'group_id': 'group_id',
            'institution_user_id': 'institution_user_id',
            'symplectic_user_id': 'symplectic_user_id',
            'quota': 'quota',
            'is_active': 'is_active'
        }

        self._email = email
        self._first_name = first_name
        self._last_name = last_name
        self._group_id = group_id
        self._institution_user_id = institution_user_id
        self._symplectic_user_id = symplectic_user_id
        self._quota = quota
        self._is_active = is_active

    @classmethod
    def from_dict(cls, dikt) -> 'AccountCreate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The AccountCreate of this AccountCreate.  # noqa: E501
        :rtype: AccountCreate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def email(self) -> str:
        """Gets the email of this AccountCreate.

        Email of account  # noqa: E501

        :return: The email of this AccountCreate.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email: str):
        """Sets the email of this AccountCreate.

        Email of account  # noqa: E501

        :param email: The email of this AccountCreate.
        :type email: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501
        if email is not None and len(email) > 150:
            raise ValueError("Invalid value for `email`, length must be less than or equal to `150`")  # noqa: E501
        if email is not None and len(email) < 3:
            raise ValueError("Invalid value for `email`, length must be greater than or equal to `3`")  # noqa: E501

        self._email = email

    @property
    def first_name(self) -> str:
        """Gets the first_name of this AccountCreate.

        First Name  # noqa: E501

        :return: The first_name of this AccountCreate.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name: str):
        """Sets the first_name of this AccountCreate.

        First Name  # noqa: E501

        :param first_name: The first_name of this AccountCreate.
        :type first_name: str
        """
        if first_name is None:
            raise ValueError("Invalid value for `first_name`, must not be `None`")  # noqa: E501
        if first_name is not None and len(first_name) > 30:
            raise ValueError("Invalid value for `first_name`, length must be less than or equal to `30`")  # noqa: E501

        self._first_name = first_name

    @property
    def last_name(self) -> str:
        """Gets the last_name of this AccountCreate.

        Last Name  # noqa: E501

        :return: The last_name of this AccountCreate.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name: str):
        """Sets the last_name of this AccountCreate.

        Last Name  # noqa: E501

        :param last_name: The last_name of this AccountCreate.
        :type last_name: str
        """
        if last_name is not None and len(last_name) > 30:
            raise ValueError("Invalid value for `last_name`, length must be less than or equal to `30`")  # noqa: E501

        self._last_name = last_name

    @property
    def group_id(self) -> int:
        """Gets the group_id of this AccountCreate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :return: The group_id of this AccountCreate.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this AccountCreate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :param group_id: The group_id of this AccountCreate.
        :type group_id: int
        """

        self._group_id = group_id

    @property
    def institution_user_id(self) -> str:
        """Gets the institution_user_id of this AccountCreate.

        Institution user id  # noqa: E501

        :return: The institution_user_id of this AccountCreate.
        :rtype: str
        """
        return self._institution_user_id

    @institution_user_id.setter
    def institution_user_id(self, institution_user_id: str):
        """Sets the institution_user_id of this AccountCreate.

        Institution user id  # noqa: E501

        :param institution_user_id: The institution_user_id of this AccountCreate.
        :type institution_user_id: str
        """
        if institution_user_id is not None and len(institution_user_id) > 50:
            raise ValueError("Invalid value for `institution_user_id`, length must be less than or equal to `50`")  # noqa: E501

        self._institution_user_id = institution_user_id

    @property
    def symplectic_user_id(self) -> str:
        """Gets the symplectic_user_id of this AccountCreate.

        Symplectic user id  # noqa: E501

        :return: The symplectic_user_id of this AccountCreate.
        :rtype: str
        """
        return self._symplectic_user_id

    @symplectic_user_id.setter
    def symplectic_user_id(self, symplectic_user_id: str):
        """Sets the symplectic_user_id of this AccountCreate.

        Symplectic user id  # noqa: E501

        :param symplectic_user_id: The symplectic_user_id of this AccountCreate.
        :type symplectic_user_id: str
        """
        if symplectic_user_id is not None and len(symplectic_user_id) > 50:
            raise ValueError("Invalid value for `symplectic_user_id`, length must be less than or equal to `50`")  # noqa: E501

        self._symplectic_user_id = symplectic_user_id

    @property
    def quota(self) -> int:
        """Gets the quota of this AccountCreate.

        Account quota  # noqa: E501

        :return: The quota of this AccountCreate.
        :rtype: int
        """
        return self._quota

    @quota.setter
    def quota(self, quota: int):
        """Sets the quota of this AccountCreate.

        Account quota  # noqa: E501

        :param quota: The quota of this AccountCreate.
        :type quota: int
        """

        self._quota = quota

    @property
    def is_active(self) -> bool:
        """Gets the is_active of this AccountCreate.

        Is account active  # noqa: E501

        :return: The is_active of this AccountCreate.
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active: bool):
        """Sets the is_active of this AccountCreate.

        Is account active  # noqa: E501

        :param is_active: The is_active of this AccountCreate.
        :type is_active: bool
        """

        self._is_active = is_active
