# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class AccountReport(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, account_id: int=None, created_date: str=None, status: str=None, download_url: str=None, group_id: int=None):  # noqa: E501
        """AccountReport - a model defined in Swagger

        :param id: The id of this AccountReport.  # noqa: E501
        :type id: int
        :param account_id: The account_id of this AccountReport.  # noqa: E501
        :type account_id: int
        :param created_date: The created_date of this AccountReport.  # noqa: E501
        :type created_date: str
        :param status: The status of this AccountReport.  # noqa: E501
        :type status: str
        :param download_url: The download_url of this AccountReport.  # noqa: E501
        :type download_url: str
        :param group_id: The group_id of this AccountReport.  # noqa: E501
        :type group_id: int
        """
        self.swagger_types = {
            'id': int,
            'account_id': int,
            'created_date': str,
            'status': str,
            'download_url': str,
            'group_id': int
        }

        self.attribute_map = {
            'id': 'id',
            'account_id': 'account_id',
            'created_date': 'created_date',
            'status': 'status',
            'download_url': 'download_url',
            'group_id': 'group_id'
        }

        self._id = id
        self._account_id = account_id
        self._created_date = created_date
        self._status = status
        self._download_url = download_url
        self._group_id = group_id

    @classmethod
    def from_dict(cls, dikt) -> 'AccountReport':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The AccountReport of this AccountReport.  # noqa: E501
        :rtype: AccountReport
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this AccountReport.

        A unique ID for the AccountRecord  # noqa: E501

        :return: The id of this AccountReport.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this AccountReport.

        A unique ID for the AccountRecord  # noqa: E501

        :param id: The id of this AccountReport.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def account_id(self) -> int:
        """Gets the account_id of this AccountReport.

        The ID of the account which generated this report.  # noqa: E501

        :return: The account_id of this AccountReport.
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id: int):
        """Sets the account_id of this AccountReport.

        The ID of the account which generated this report.  # noqa: E501

        :param account_id: The account_id of this AccountReport.
        :type account_id: int
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def created_date(self) -> str:
        """Gets the created_date of this AccountReport.

        Date when the AccountReport was requested  # noqa: E501

        :return: The created_date of this AccountReport.
        :rtype: str
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date: str):
        """Sets the created_date of this AccountReport.

        Date when the AccountReport was requested  # noqa: E501

        :param created_date: The created_date of this AccountReport.
        :type created_date: str
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    @property
    def status(self) -> str:
        """Gets the status of this AccountReport.

        Status of the report  # noqa: E501

        :return: The status of this AccountReport.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this AccountReport.

        Status of the report  # noqa: E501

        :param status: The status of this AccountReport.
        :type status: str
        """
        allowed_values = ["missing", "pending", "done"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def download_url(self) -> str:
        """Gets the download_url of this AccountReport.

        The download link for the generated XLSX  # noqa: E501

        :return: The download_url of this AccountReport.
        :rtype: str
        """
        return self._download_url

    @download_url.setter
    def download_url(self, download_url: str):
        """Sets the download_url of this AccountReport.

        The download link for the generated XLSX  # noqa: E501

        :param download_url: The download_url of this AccountReport.
        :type download_url: str
        """
        if download_url is None:
            raise ValueError("Invalid value for `download_url`, must not be `None`")  # noqa: E501

        self._download_url = download_url

    @property
    def group_id(self) -> int:
        """Gets the group_id of this AccountReport.

        The group ID that was used to filter the report, if any.  # noqa: E501

        :return: The group_id of this AccountReport.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this AccountReport.

        The group ID that was used to filter the report, if any.  # noqa: E501

        :param group_id: The group_id of this AccountReport.
        :type group_id: int
        """
        if group_id is None:
            raise ValueError("Invalid value for `group_id`, must not be `None`")  # noqa: E501

        self._group_id = group_id
