# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class ArticleEmbargoUpdater(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, is_embargoed: bool=None, embargo_date: str=None, embargo_type: str=None, embargo_title: str=None, embargo_reason: str=None, embargo_options: List[object]=None):  # noqa: E501
        """ArticleEmbargoUpdater - a model defined in Swagger

        :param is_embargoed: The is_embargoed of this ArticleEmbargoUpdater.  # noqa: E501
        :type is_embargoed: bool
        :param embargo_date: The embargo_date of this ArticleEmbargoUpdater.  # noqa: E501
        :type embargo_date: str
        :param embargo_type: The embargo_type of this ArticleEmbargoUpdater.  # noqa: E501
        :type embargo_type: str
        :param embargo_title: The embargo_title of this ArticleEmbargoUpdater.  # noqa: E501
        :type embargo_title: str
        :param embargo_reason: The embargo_reason of this ArticleEmbargoUpdater.  # noqa: E501
        :type embargo_reason: str
        :param embargo_options: The embargo_options of this ArticleEmbargoUpdater.  # noqa: E501
        :type embargo_options: List[object]
        """
        self.swagger_types = {
            'is_embargoed': bool,
            'embargo_date': str,
            'embargo_type': str,
            'embargo_title': str,
            'embargo_reason': str,
            'embargo_options': List[object]
        }

        self.attribute_map = {
            'is_embargoed': 'is_embargoed',
            'embargo_date': 'embargo_date',
            'embargo_type': 'embargo_type',
            'embargo_title': 'embargo_title',
            'embargo_reason': 'embargo_reason',
            'embargo_options': 'embargo_options'
        }

        self._is_embargoed = is_embargoed
        self._embargo_date = embargo_date
        self._embargo_type = embargo_type
        self._embargo_title = embargo_title
        self._embargo_reason = embargo_reason
        self._embargo_options = embargo_options

    @classmethod
    def from_dict(cls, dikt) -> 'ArticleEmbargoUpdater':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ArticleEmbargoUpdater of this ArticleEmbargoUpdater.  # noqa: E501
        :rtype: ArticleEmbargoUpdater
        """
        return util.deserialize_model(dikt, cls)

    @property
    def is_embargoed(self) -> bool:
        """Gets the is_embargoed of this ArticleEmbargoUpdater.

        Embargo status  # noqa: E501

        :return: The is_embargoed of this ArticleEmbargoUpdater.
        :rtype: bool
        """
        return self._is_embargoed

    @is_embargoed.setter
    def is_embargoed(self, is_embargoed: bool):
        """Sets the is_embargoed of this ArticleEmbargoUpdater.

        Embargo status  # noqa: E501

        :param is_embargoed: The is_embargoed of this ArticleEmbargoUpdater.
        :type is_embargoed: bool
        """
        if is_embargoed is None:
            raise ValueError("Invalid value for `is_embargoed`, must not be `None`")  # noqa: E501

        self._is_embargoed = is_embargoed

    @property
    def embargo_date(self) -> str:
        """Gets the embargo_date of this ArticleEmbargoUpdater.

        Date when the embargo expires and the article gets published, '0' value will set up permanent embargo  # noqa: E501

        :return: The embargo_date of this ArticleEmbargoUpdater.
        :rtype: str
        """
        return self._embargo_date

    @embargo_date.setter
    def embargo_date(self, embargo_date: str):
        """Sets the embargo_date of this ArticleEmbargoUpdater.

        Date when the embargo expires and the article gets published, '0' value will set up permanent embargo  # noqa: E501

        :param embargo_date: The embargo_date of this ArticleEmbargoUpdater.
        :type embargo_date: str
        """
        if embargo_date is None:
            raise ValueError("Invalid value for `embargo_date`, must not be `None`")  # noqa: E501

        self._embargo_date = embargo_date

    @property
    def embargo_type(self) -> str:
        """Gets the embargo_type of this ArticleEmbargoUpdater.

        Embargo can be enabled at the article or the file level. Possible values: article, file  # noqa: E501

        :return: The embargo_type of this ArticleEmbargoUpdater.
        :rtype: str
        """
        return self._embargo_type

    @embargo_type.setter
    def embargo_type(self, embargo_type: str):
        """Sets the embargo_type of this ArticleEmbargoUpdater.

        Embargo can be enabled at the article or the file level. Possible values: article, file  # noqa: E501

        :param embargo_type: The embargo_type of this ArticleEmbargoUpdater.
        :type embargo_type: str
        """
        allowed_values = ["article", "file"]  # noqa: E501
        if embargo_type not in allowed_values:
            raise ValueError(
                "Invalid value for `embargo_type` ({0}), must be one of {1}"
                .format(embargo_type, allowed_values)
            )

        self._embargo_type = embargo_type

    @property
    def embargo_title(self) -> str:
        """Gets the embargo_title of this ArticleEmbargoUpdater.

        Title for embargo  # noqa: E501

        :return: The embargo_title of this ArticleEmbargoUpdater.
        :rtype: str
        """
        return self._embargo_title

    @embargo_title.setter
    def embargo_title(self, embargo_title: str):
        """Sets the embargo_title of this ArticleEmbargoUpdater.

        Title for embargo  # noqa: E501

        :param embargo_title: The embargo_title of this ArticleEmbargoUpdater.
        :type embargo_title: str
        """

        self._embargo_title = embargo_title

    @property
    def embargo_reason(self) -> str:
        """Gets the embargo_reason of this ArticleEmbargoUpdater.

        Reason for setting embargo  # noqa: E501

        :return: The embargo_reason of this ArticleEmbargoUpdater.
        :rtype: str
        """
        return self._embargo_reason

    @embargo_reason.setter
    def embargo_reason(self, embargo_reason: str):
        """Sets the embargo_reason of this ArticleEmbargoUpdater.

        Reason for setting embargo  # noqa: E501

        :param embargo_reason: The embargo_reason of this ArticleEmbargoUpdater.
        :type embargo_reason: str
        """

        self._embargo_reason = embargo_reason

    @property
    def embargo_options(self) -> List[object]:
        """Gets the embargo_options of this ArticleEmbargoUpdater.

        List of embargo permissions to be associated with the article. The list must contain `id` and can also contain `group_ids`(a field that only applies to 'logged_in' permissions). The new list replaces old options in the database, and an empty list removes all permissions for this article. Administration permission has to be set up alone but logged in and IP range permissions can be set up together.  # noqa: E501

        :return: The embargo_options of this ArticleEmbargoUpdater.
        :rtype: List[object]
        """
        return self._embargo_options

    @embargo_options.setter
    def embargo_options(self, embargo_options: List[object]):
        """Sets the embargo_options of this ArticleEmbargoUpdater.

        List of embargo permissions to be associated with the article. The list must contain `id` and can also contain `group_ids`(a field that only applies to 'logged_in' permissions). The new list replaces old options in the database, and an empty list removes all permissions for this article. Administration permission has to be set up alone but logged in and IP range permissions can be set up together.  # noqa: E501

        :param embargo_options: The embargo_options of this ArticleEmbargoUpdater.
        :type embargo_options: List[object]
        """

        self._embargo_options = embargo_options
