# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Category(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, parent_id: int=None, id: int=None, title: str=None, path: str=None, source_id: str=None, taxonomy_id: int=None):  # noqa: E501
        """Category - a model defined in Swagger

        :param parent_id: The parent_id of this Category.  # noqa: E501
        :type parent_id: int
        :param id: The id of this Category.  # noqa: E501
        :type id: int
        :param title: The title of this Category.  # noqa: E501
        :type title: str
        :param path: The path of this Category.  # noqa: E501
        :type path: str
        :param source_id: The source_id of this Category.  # noqa: E501
        :type source_id: str
        :param taxonomy_id: The taxonomy_id of this Category.  # noqa: E501
        :type taxonomy_id: int
        """
        self.swagger_types = {
            'parent_id': int,
            'id': int,
            'title': str,
            'path': str,
            'source_id': str,
            'taxonomy_id': int
        }

        self.attribute_map = {
            'parent_id': 'parent_id',
            'id': 'id',
            'title': 'title',
            'path': 'path',
            'source_id': 'source_id',
            'taxonomy_id': 'taxonomy_id'
        }

        self._parent_id = parent_id
        self._id = id
        self._title = title
        self._path = path
        self._source_id = source_id
        self._taxonomy_id = taxonomy_id

    @classmethod
    def from_dict(cls, dikt) -> 'Category':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Category of this Category.  # noqa: E501
        :rtype: Category
        """
        return util.deserialize_model(dikt, cls)

    @property
    def parent_id(self) -> int:
        """Gets the parent_id of this Category.

        Parent category  # noqa: E501

        :return: The parent_id of this Category.
        :rtype: int
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id: int):
        """Sets the parent_id of this Category.

        Parent category  # noqa: E501

        :param parent_id: The parent_id of this Category.
        :type parent_id: int
        """
        if parent_id is None:
            raise ValueError("Invalid value for `parent_id`, must not be `None`")  # noqa: E501

        self._parent_id = parent_id

    @property
    def id(self) -> int:
        """Gets the id of this Category.

        Category id  # noqa: E501

        :return: The id of this Category.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Category.

        Category id  # noqa: E501

        :param id: The id of this Category.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this Category.

        Category title  # noqa: E501

        :return: The title of this Category.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this Category.

        Category title  # noqa: E501

        :param title: The title of this Category.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def path(self) -> str:
        """Gets the path of this Category.

        Path to all ancestor ids  # noqa: E501

        :return: The path of this Category.
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path: str):
        """Sets the path of this Category.

        Path to all ancestor ids  # noqa: E501

        :param path: The path of this Category.
        :type path: str
        """
        if path is None:
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    @property
    def source_id(self) -> str:
        """Gets the source_id of this Category.

        ID in original standard taxonomy  # noqa: E501

        :return: The source_id of this Category.
        :rtype: str
        """
        return self._source_id

    @source_id.setter
    def source_id(self, source_id: str):
        """Sets the source_id of this Category.

        ID in original standard taxonomy  # noqa: E501

        :param source_id: The source_id of this Category.
        :type source_id: str
        """
        if source_id is None:
            raise ValueError("Invalid value for `source_id`, must not be `None`")  # noqa: E501

        self._source_id = source_id

    @property
    def taxonomy_id(self) -> int:
        """Gets the taxonomy_id of this Category.

        Internal id of taxonomy the category is part of  # noqa: E501

        :return: The taxonomy_id of this Category.
        :rtype: int
        """
        return self._taxonomy_id

    @taxonomy_id.setter
    def taxonomy_id(self, taxonomy_id: int):
        """Sets the taxonomy_id of this Category.

        Internal id of taxonomy the category is part of  # noqa: E501

        :param taxonomy_id: The taxonomy_id of this Category.
        :type taxonomy_id: int
        """
        if taxonomy_id is None:
            raise ValueError("Invalid value for `taxonomy_id`, must not be `None`")  # noqa: E501

        self._taxonomy_id = taxonomy_id
