# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.custom_article_field_add import CustomArticleFieldAdd
from swagger_server.models.funding_create import FundingCreate
from swagger_server.models.timeline_update import TimelineUpdate
from swagger_server import util


class CollectionCreate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, funding: str='', funding_list: List[FundingCreate]=None, title: str=None, description: str='', articles: List[int]=None, authors: List[object]=None, categories: List[int]=None, categories_by_source_id: List[str]=None, tags: List[str]=None, keywords: List[str]=None, references: List[str]=None, custom_fields: object=None, custom_fields_list: List[CustomArticleFieldAdd]=None, doi: str='', handle: str='', resource_id: str=None, resource_doi: str='', resource_link: str=None, resource_title: str='', resource_version: int=None, group_id: int=None, timeline: TimelineUpdate=None):  # noqa: E501
        """CollectionCreate - a model defined in Swagger

        :param funding: The funding of this CollectionCreate.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this CollectionCreate.  # noqa: E501
        :type funding_list: List[FundingCreate]
        :param title: The title of this CollectionCreate.  # noqa: E501
        :type title: str
        :param description: The description of this CollectionCreate.  # noqa: E501
        :type description: str
        :param articles: The articles of this CollectionCreate.  # noqa: E501
        :type articles: List[int]
        :param authors: The authors of this CollectionCreate.  # noqa: E501
        :type authors: List[object]
        :param categories: The categories of this CollectionCreate.  # noqa: E501
        :type categories: List[int]
        :param categories_by_source_id: The categories_by_source_id of this CollectionCreate.  # noqa: E501
        :type categories_by_source_id: List[str]
        :param tags: The tags of this CollectionCreate.  # noqa: E501
        :type tags: List[str]
        :param keywords: The keywords of this CollectionCreate.  # noqa: E501
        :type keywords: List[str]
        :param references: The references of this CollectionCreate.  # noqa: E501
        :type references: List[str]
        :param custom_fields: The custom_fields of this CollectionCreate.  # noqa: E501
        :type custom_fields: object
        :param custom_fields_list: The custom_fields_list of this CollectionCreate.  # noqa: E501
        :type custom_fields_list: List[CustomArticleFieldAdd]
        :param doi: The doi of this CollectionCreate.  # noqa: E501
        :type doi: str
        :param handle: The handle of this CollectionCreate.  # noqa: E501
        :type handle: str
        :param resource_id: The resource_id of this CollectionCreate.  # noqa: E501
        :type resource_id: str
        :param resource_doi: The resource_doi of this CollectionCreate.  # noqa: E501
        :type resource_doi: str
        :param resource_link: The resource_link of this CollectionCreate.  # noqa: E501
        :type resource_link: str
        :param resource_title: The resource_title of this CollectionCreate.  # noqa: E501
        :type resource_title: str
        :param resource_version: The resource_version of this CollectionCreate.  # noqa: E501
        :type resource_version: int
        :param group_id: The group_id of this CollectionCreate.  # noqa: E501
        :type group_id: int
        :param timeline: The timeline of this CollectionCreate.  # noqa: E501
        :type timeline: TimelineUpdate
        """
        self.swagger_types = {
            'funding': str,
            'funding_list': List[FundingCreate],
            'title': str,
            'description': str,
            'articles': List[int],
            'authors': List[object],
            'categories': List[int],
            'categories_by_source_id': List[str],
            'tags': List[str],
            'keywords': List[str],
            'references': List[str],
            'custom_fields': object,
            'custom_fields_list': List[CustomArticleFieldAdd],
            'doi': str,
            'handle': str,
            'resource_id': str,
            'resource_doi': str,
            'resource_link': str,
            'resource_title': str,
            'resource_version': int,
            'group_id': int,
            'timeline': TimelineUpdate
        }

        self.attribute_map = {
            'funding': 'funding',
            'funding_list': 'funding_list',
            'title': 'title',
            'description': 'description',
            'articles': 'articles',
            'authors': 'authors',
            'categories': 'categories',
            'categories_by_source_id': 'categories_by_source_id',
            'tags': 'tags',
            'keywords': 'keywords',
            'references': 'references',
            'custom_fields': 'custom_fields',
            'custom_fields_list': 'custom_fields_list',
            'doi': 'doi',
            'handle': 'handle',
            'resource_id': 'resource_id',
            'resource_doi': 'resource_doi',
            'resource_link': 'resource_link',
            'resource_title': 'resource_title',
            'resource_version': 'resource_version',
            'group_id': 'group_id',
            'timeline': 'timeline'
        }

        self._funding = funding
        self._funding_list = funding_list
        self._title = title
        self._description = description
        self._articles = articles
        self._authors = authors
        self._categories = categories
        self._categories_by_source_id = categories_by_source_id
        self._tags = tags
        self._keywords = keywords
        self._references = references
        self._custom_fields = custom_fields
        self._custom_fields_list = custom_fields_list
        self._doi = doi
        self._handle = handle
        self._resource_id = resource_id
        self._resource_doi = resource_doi
        self._resource_link = resource_link
        self._resource_title = resource_title
        self._resource_version = resource_version
        self._group_id = group_id
        self._timeline = timeline

    @classmethod
    def from_dict(cls, dikt) -> 'CollectionCreate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The CollectionCreate of this CollectionCreate.  # noqa: E501
        :rtype: CollectionCreate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def funding(self) -> str:
        """Gets the funding of this CollectionCreate.

        Grant number or funding authority  # noqa: E501

        :return: The funding of this CollectionCreate.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this CollectionCreate.

        Grant number or funding authority  # noqa: E501

        :param funding: The funding of this CollectionCreate.
        :type funding: str
        """

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingCreate]:
        """Gets the funding_list of this CollectionCreate.

        Funding creation / update items  # noqa: E501

        :return: The funding_list of this CollectionCreate.
        :rtype: List[FundingCreate]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingCreate]):
        """Sets the funding_list of this CollectionCreate.

        Funding creation / update items  # noqa: E501

        :param funding_list: The funding_list of this CollectionCreate.
        :type funding_list: List[FundingCreate]
        """

        self._funding_list = funding_list

    @property
    def title(self) -> str:
        """Gets the title of this CollectionCreate.

        Title of collection  # noqa: E501

        :return: The title of this CollectionCreate.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this CollectionCreate.

        Title of collection  # noqa: E501

        :param title: The title of this CollectionCreate.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501
        if title is not None and len(title) > 1000:
            raise ValueError("Invalid value for `title`, length must be less than or equal to `1000`")  # noqa: E501
        if title is not None and len(title) < 3:
            raise ValueError("Invalid value for `title`, length must be greater than or equal to `3`")  # noqa: E501

        self._title = title

    @property
    def description(self) -> str:
        """Gets the description of this CollectionCreate.

        The collection description. In a publisher case, usually this is the remote collection description  # noqa: E501

        :return: The description of this CollectionCreate.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this CollectionCreate.

        The collection description. In a publisher case, usually this is the remote collection description  # noqa: E501

        :param description: The description of this CollectionCreate.
        :type description: str
        """
        if description is not None and len(description) > 10000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `10000`")  # noqa: E501

        self._description = description

    @property
    def articles(self) -> List[int]:
        """Gets the articles of this CollectionCreate.

        List of articles to be associated with the collection  # noqa: E501

        :return: The articles of this CollectionCreate.
        :rtype: List[int]
        """
        return self._articles

    @articles.setter
    def articles(self, articles: List[int]):
        """Sets the articles of this CollectionCreate.

        List of articles to be associated with the collection  # noqa: E501

        :param articles: The articles of this CollectionCreate.
        :type articles: List[int]
        """

        self._articles = articles

    @property
    def authors(self) -> List[object]:
        """Gets the authors of this CollectionCreate.

        List of authors to be associated with the collection. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.  # noqa: E501

        :return: The authors of this CollectionCreate.
        :rtype: List[object]
        """
        return self._authors

    @authors.setter
    def authors(self, authors: List[object]):
        """Sets the authors of this CollectionCreate.

        List of authors to be associated with the collection. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.  # noqa: E501

        :param authors: The authors of this CollectionCreate.
        :type authors: List[object]
        """

        self._authors = authors

    @property
    def categories(self) -> List[int]:
        """Gets the categories of this CollectionCreate.

        List of category ids to be associated with the collection(e.g [1, 23, 33, 66])  # noqa: E501

        :return: The categories of this CollectionCreate.
        :rtype: List[int]
        """
        return self._categories

    @categories.setter
    def categories(self, categories: List[int]):
        """Sets the categories of this CollectionCreate.

        List of category ids to be associated with the collection(e.g [1, 23, 33, 66])  # noqa: E501

        :param categories: The categories of this CollectionCreate.
        :type categories: List[int]
        """

        self._categories = categories

    @property
    def categories_by_source_id(self) -> List[str]:
        """Gets the categories_by_source_id of this CollectionCreate.

        List of category source ids to be associated with the collection, supersedes the categories property  # noqa: E501

        :return: The categories_by_source_id of this CollectionCreate.
        :rtype: List[str]
        """
        return self._categories_by_source_id

    @categories_by_source_id.setter
    def categories_by_source_id(self, categories_by_source_id: List[str]):
        """Sets the categories_by_source_id of this CollectionCreate.

        List of category source ids to be associated with the collection, supersedes the categories property  # noqa: E501

        :param categories_by_source_id: The categories_by_source_id of this CollectionCreate.
        :type categories_by_source_id: List[str]
        """

        self._categories_by_source_id = categories_by_source_id

    @property
    def tags(self) -> List[str]:
        """Gets the tags of this CollectionCreate.

        List of tags to be associated with the collection. Keywords can be used instead  # noqa: E501

        :return: The tags of this CollectionCreate.
        :rtype: List[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags: List[str]):
        """Sets the tags of this CollectionCreate.

        List of tags to be associated with the collection. Keywords can be used instead  # noqa: E501

        :param tags: The tags of this CollectionCreate.
        :type tags: List[str]
        """

        self._tags = tags

    @property
    def keywords(self) -> List[str]:
        """Gets the keywords of this CollectionCreate.

        List of tags to be associated with the collection. Tags can be used instead  # noqa: E501

        :return: The keywords of this CollectionCreate.
        :rtype: List[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords: List[str]):
        """Sets the keywords of this CollectionCreate.

        List of tags to be associated with the collection. Tags can be used instead  # noqa: E501

        :param keywords: The keywords of this CollectionCreate.
        :type keywords: List[str]
        """

        self._keywords = keywords

    @property
    def references(self) -> List[str]:
        """Gets the references of this CollectionCreate.

        List of links to be associated with the collection (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])  # noqa: E501

        :return: The references of this CollectionCreate.
        :rtype: List[str]
        """
        return self._references

    @references.setter
    def references(self, references: List[str]):
        """Sets the references of this CollectionCreate.

        List of links to be associated with the collection (e.g [\"http://link1\", \"http://link2\", \"http://link3\"])  # noqa: E501

        :param references: The references of this CollectionCreate.
        :type references: List[str]
        """

        self._references = references

    @property
    def custom_fields(self) -> object:
        """Gets the custom_fields of this CollectionCreate.

        List of key, values pairs to be associated with the collection  # noqa: E501

        :return: The custom_fields of this CollectionCreate.
        :rtype: object
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields: object):
        """Sets the custom_fields of this CollectionCreate.

        List of key, values pairs to be associated with the collection  # noqa: E501

        :param custom_fields: The custom_fields of this CollectionCreate.
        :type custom_fields: object
        """

        self._custom_fields = custom_fields

    @property
    def custom_fields_list(self) -> List[CustomArticleFieldAdd]:
        """Gets the custom_fields_list of this CollectionCreate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :return: The custom_fields_list of this CollectionCreate.
        :rtype: List[CustomArticleFieldAdd]
        """
        return self._custom_fields_list

    @custom_fields_list.setter
    def custom_fields_list(self, custom_fields_list: List[CustomArticleFieldAdd]):
        """Sets the custom_fields_list of this CollectionCreate.

        List of custom fields values, supersedes custom_fields parameter  # noqa: E501

        :param custom_fields_list: The custom_fields_list of this CollectionCreate.
        :type custom_fields_list: List[CustomArticleFieldAdd]
        """

        self._custom_fields_list = custom_fields_list

    @property
    def doi(self) -> str:
        """Gets the doi of this CollectionCreate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :return: The doi of this CollectionCreate.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this CollectionCreate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :param doi: The doi of this CollectionCreate.
        :type doi: str
        """

        self._doi = doi

    @property
    def handle(self) -> str:
        """Gets the handle of this CollectionCreate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :return: The handle of this CollectionCreate.
        :rtype: str
        """
        return self._handle

    @handle.setter
    def handle(self, handle: str):
        """Sets the handle of this CollectionCreate.

        Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.  # noqa: E501

        :param handle: The handle of this CollectionCreate.
        :type handle: str
        """

        self._handle = handle

    @property
    def resource_id(self) -> str:
        """Gets the resource_id of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article id  # noqa: E501

        :return: The resource_id of this CollectionCreate.
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id: str):
        """Sets the resource_id of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article id  # noqa: E501

        :param resource_id: The resource_id of this CollectionCreate.
        :type resource_id: str
        """

        self._resource_id = resource_id

    @property
    def resource_doi(self) -> str:
        """Gets the resource_doi of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article DOI.  # noqa: E501

        :return: The resource_doi of this CollectionCreate.
        :rtype: str
        """
        return self._resource_doi

    @resource_doi.setter
    def resource_doi(self, resource_doi: str):
        """Sets the resource_doi of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article DOI.  # noqa: E501

        :param resource_doi: The resource_doi of this CollectionCreate.
        :type resource_doi: str
        """

        self._resource_doi = resource_doi

    @property
    def resource_link(self) -> str:
        """Gets the resource_link of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article link  # noqa: E501

        :return: The resource_link of this CollectionCreate.
        :rtype: str
        """
        return self._resource_link

    @resource_link.setter
    def resource_link(self, resource_link: str):
        """Sets the resource_link of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article link  # noqa: E501

        :param resource_link: The resource_link of this CollectionCreate.
        :type resource_link: str
        """

        self._resource_link = resource_link

    @property
    def resource_title(self) -> str:
        """Gets the resource_title of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article title.  # noqa: E501

        :return: The resource_title of this CollectionCreate.
        :rtype: str
        """
        return self._resource_title

    @resource_title.setter
    def resource_title(self, resource_title: str):
        """Sets the resource_title of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article title.  # noqa: E501

        :param resource_title: The resource_title of this CollectionCreate.
        :type resource_title: str
        """

        self._resource_title = resource_title

    @property
    def resource_version(self) -> int:
        """Gets the resource_version of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article version  # noqa: E501

        :return: The resource_version of this CollectionCreate.
        :rtype: int
        """
        return self._resource_version

    @resource_version.setter
    def resource_version(self, resource_version: int):
        """Sets the resource_version of this CollectionCreate.

        Not applicable to regular users. In a publisher case, this is the publisher article version  # noqa: E501

        :param resource_version: The resource_version of this CollectionCreate.
        :type resource_version: int
        """

        self._resource_version = resource_version

    @property
    def group_id(self) -> int:
        """Gets the group_id of this CollectionCreate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :return: The group_id of this CollectionCreate.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this CollectionCreate.

        Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups  # noqa: E501

        :param group_id: The group_id of this CollectionCreate.
        :type group_id: int
        """

        self._group_id = group_id

    @property
    def timeline(self) -> TimelineUpdate:
        """Gets the timeline of this CollectionCreate.

        Various timeline dates  # noqa: E501

        :return: The timeline of this CollectionCreate.
        :rtype: TimelineUpdate
        """
        return self._timeline

    @timeline.setter
    def timeline(self, timeline: TimelineUpdate):
        """Sets the timeline of this CollectionCreate.

        Various timeline dates  # noqa: E501

        :param timeline: The timeline of this CollectionCreate.
        :type timeline: TimelineUpdate
        """

        self._timeline = timeline
