# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Curation(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, group_id: int=None, account_id: int=None, assigned_to: int=None, article_id: int=None, version: int=None, comments_count: int=None, status: str=None, created_date: str=None, modified_date: str=None):  # noqa: E501
        """Curation - a model defined in Swagger

        :param id: The id of this Curation.  # noqa: E501
        :type id: int
        :param group_id: The group_id of this Curation.  # noqa: E501
        :type group_id: int
        :param account_id: The account_id of this Curation.  # noqa: E501
        :type account_id: int
        :param assigned_to: The assigned_to of this Curation.  # noqa: E501
        :type assigned_to: int
        :param article_id: The article_id of this Curation.  # noqa: E501
        :type article_id: int
        :param version: The version of this Curation.  # noqa: E501
        :type version: int
        :param comments_count: The comments_count of this Curation.  # noqa: E501
        :type comments_count: int
        :param status: The status of this Curation.  # noqa: E501
        :type status: str
        :param created_date: The created_date of this Curation.  # noqa: E501
        :type created_date: str
        :param modified_date: The modified_date of this Curation.  # noqa: E501
        :type modified_date: str
        """
        self.swagger_types = {
            'id': int,
            'group_id': int,
            'account_id': int,
            'assigned_to': int,
            'article_id': int,
            'version': int,
            'comments_count': int,
            'status': str,
            'created_date': str,
            'modified_date': str
        }

        self.attribute_map = {
            'id': 'id',
            'group_id': 'group_id',
            'account_id': 'account_id',
            'assigned_to': 'assigned_to',
            'article_id': 'article_id',
            'version': 'version',
            'comments_count': 'comments_count',
            'status': 'status',
            'created_date': 'created_date',
            'modified_date': 'modified_date'
        }

        self._id = id
        self._group_id = group_id
        self._account_id = account_id
        self._assigned_to = assigned_to
        self._article_id = article_id
        self._version = version
        self._comments_count = comments_count
        self._status = status
        self._created_date = created_date
        self._modified_date = modified_date

    @classmethod
    def from_dict(cls, dikt) -> 'Curation':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Curation of this Curation.  # noqa: E501
        :rtype: Curation
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Curation.

        The review id  # noqa: E501

        :return: The id of this Curation.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Curation.

        The review id  # noqa: E501

        :param id: The id of this Curation.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def group_id(self) -> int:
        """Gets the group_id of this Curation.

        The group in which the article is present.  # noqa: E501

        :return: The group_id of this Curation.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this Curation.

        The group in which the article is present.  # noqa: E501

        :param group_id: The group_id of this Curation.
        :type group_id: int
        """
        if group_id is None:
            raise ValueError("Invalid value for `group_id`, must not be `None`")  # noqa: E501

        self._group_id = group_id

    @property
    def account_id(self) -> int:
        """Gets the account_id of this Curation.

        The ID of the account of the owner of the article of this review.  # noqa: E501

        :return: The account_id of this Curation.
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id: int):
        """Sets the account_id of this Curation.

        The ID of the account of the owner of the article of this review.  # noqa: E501

        :param account_id: The account_id of this Curation.
        :type account_id: int
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def assigned_to(self) -> int:
        """Gets the assigned_to of this Curation.

        The ID of the account to which this review is assigned.  # noqa: E501

        :return: The assigned_to of this Curation.
        :rtype: int
        """
        return self._assigned_to

    @assigned_to.setter
    def assigned_to(self, assigned_to: int):
        """Sets the assigned_to of this Curation.

        The ID of the account to which this review is assigned.  # noqa: E501

        :param assigned_to: The assigned_to of this Curation.
        :type assigned_to: int
        """
        if assigned_to is None:
            raise ValueError("Invalid value for `assigned_to`, must not be `None`")  # noqa: E501

        self._assigned_to = assigned_to

    @property
    def article_id(self) -> int:
        """Gets the article_id of this Curation.

        The ID of the article of this review.  # noqa: E501

        :return: The article_id of this Curation.
        :rtype: int
        """
        return self._article_id

    @article_id.setter
    def article_id(self, article_id: int):
        """Sets the article_id of this Curation.

        The ID of the article of this review.  # noqa: E501

        :param article_id: The article_id of this Curation.
        :type article_id: int
        """
        if article_id is None:
            raise ValueError("Invalid value for `article_id`, must not be `None`")  # noqa: E501

        self._article_id = article_id

    @property
    def version(self) -> int:
        """Gets the version of this Curation.

        The Version number of the article in review.  # noqa: E501

        :return: The version of this Curation.
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version: int):
        """Sets the version of this Curation.

        The Version number of the article in review.  # noqa: E501

        :param version: The version of this Curation.
        :type version: int
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def comments_count(self) -> int:
        """Gets the comments_count of this Curation.

        The number of comments in the review.  # noqa: E501

        :return: The comments_count of this Curation.
        :rtype: int
        """
        return self._comments_count

    @comments_count.setter
    def comments_count(self, comments_count: int):
        """Sets the comments_count of this Curation.

        The number of comments in the review.  # noqa: E501

        :param comments_count: The comments_count of this Curation.
        :type comments_count: int
        """
        if comments_count is None:
            raise ValueError("Invalid value for `comments_count`, must not be `None`")  # noqa: E501

        self._comments_count = comments_count

    @property
    def status(self) -> str:
        """Gets the status of this Curation.

        The status of the review.  # noqa: E501

        :return: The status of this Curation.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this Curation.

        The status of the review.  # noqa: E501

        :param status: The status of this Curation.
        :type status: str
        """
        allowed_values = ["pending", "approved", "rejected", "closed"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def created_date(self) -> str:
        """Gets the created_date of this Curation.

        The creation date of the review.  # noqa: E501

        :return: The created_date of this Curation.
        :rtype: str
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date: str):
        """Sets the created_date of this Curation.

        The creation date of the review.  # noqa: E501

        :param created_date: The created_date of this Curation.
        :type created_date: str
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    @property
    def modified_date(self) -> str:
        """Gets the modified_date of this Curation.

        The date the review has been modified.  # noqa: E501

        :return: The modified_date of this Curation.
        :rtype: str
        """
        return self._modified_date

    @modified_date.setter
    def modified_date(self, modified_date: str):
        """Sets the modified_date of this Curation.

        The date the review has been modified.  # noqa: E501

        :param modified_date: The modified_date of this Curation.
        :type modified_date: str
        """
        if modified_date is None:
            raise ValueError("Invalid value for `modified_date`, must not be `None`")  # noqa: E501

        self._modified_date = modified_date
