# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class InstitutionAccountsSearch(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, search_for: str=None, is_active: int=None, page: int=None, page_size: int=10, limit: int=None, offset: int=None, institution_user_id: str=None, email: str=None):  # noqa: E501
        """InstitutionAccountsSearch - a model defined in Swagger

        :param search_for: The search_for of this InstitutionAccountsSearch.  # noqa: E501
        :type search_for: str
        :param is_active: The is_active of this InstitutionAccountsSearch.  # noqa: E501
        :type is_active: int
        :param page: The page of this InstitutionAccountsSearch.  # noqa: E501
        :type page: int
        :param page_size: The page_size of this InstitutionAccountsSearch.  # noqa: E501
        :type page_size: int
        :param limit: The limit of this InstitutionAccountsSearch.  # noqa: E501
        :type limit: int
        :param offset: The offset of this InstitutionAccountsSearch.  # noqa: E501
        :type offset: int
        :param institution_user_id: The institution_user_id of this InstitutionAccountsSearch.  # noqa: E501
        :type institution_user_id: str
        :param email: The email of this InstitutionAccountsSearch.  # noqa: E501
        :type email: str
        """
        self.swagger_types = {
            'search_for': str,
            'is_active': int,
            'page': int,
            'page_size': int,
            'limit': int,
            'offset': int,
            'institution_user_id': str,
            'email': str
        }

        self.attribute_map = {
            'search_for': 'search_for',
            'is_active': 'is_active',
            'page': 'page',
            'page_size': 'page_size',
            'limit': 'limit',
            'offset': 'offset',
            'institution_user_id': 'institution_user_id',
            'email': 'email'
        }

        self._search_for = search_for
        self._is_active = is_active
        self._page = page
        self._page_size = page_size
        self._limit = limit
        self._offset = offset
        self._institution_user_id = institution_user_id
        self._email = email

    @classmethod
    def from_dict(cls, dikt) -> 'InstitutionAccountsSearch':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The InstitutionAccountsSearch of this InstitutionAccountsSearch.  # noqa: E501
        :rtype: InstitutionAccountsSearch
        """
        return util.deserialize_model(dikt, cls)

    @property
    def search_for(self) -> str:
        """Gets the search_for of this InstitutionAccountsSearch.

        Search term  # noqa: E501

        :return: The search_for of this InstitutionAccountsSearch.
        :rtype: str
        """
        return self._search_for

    @search_for.setter
    def search_for(self, search_for: str):
        """Sets the search_for of this InstitutionAccountsSearch.

        Search term  # noqa: E501

        :param search_for: The search_for of this InstitutionAccountsSearch.
        :type search_for: str
        """

        self._search_for = search_for

    @property
    def is_active(self) -> int:
        """Gets the is_active of this InstitutionAccountsSearch.

        Filter by active status  # noqa: E501

        :return: The is_active of this InstitutionAccountsSearch.
        :rtype: int
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active: int):
        """Sets the is_active of this InstitutionAccountsSearch.

        Filter by active status  # noqa: E501

        :param is_active: The is_active of this InstitutionAccountsSearch.
        :type is_active: int
        """
        if is_active is not None and is_active > 1:  # noqa: E501
            raise ValueError("Invalid value for `is_active`, must be a value less than or equal to `1`")  # noqa: E501
        if is_active is not None and is_active < 0:  # noqa: E501
            raise ValueError("Invalid value for `is_active`, must be a value greater than or equal to `0`")  # noqa: E501

        self._is_active = is_active

    @property
    def page(self) -> int:
        """Gets the page of this InstitutionAccountsSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :return: The page of this InstitutionAccountsSearch.
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page: int):
        """Sets the page of this InstitutionAccountsSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :param page: The page of this InstitutionAccountsSearch.
        :type page: int
        """
        if page is not None and page > 5000:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value less than or equal to `5000`")  # noqa: E501
        if page is not None and page < 1:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page = page

    @property
    def page_size(self) -> int:
        """Gets the page_size of this InstitutionAccountsSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :return: The page_size of this InstitutionAccountsSearch.
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size: int):
        """Sets the page_size of this InstitutionAccountsSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :param page_size: The page_size of this InstitutionAccountsSearch.
        :type page_size: int
        """
        if page_size is not None and page_size > 1000:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value less than or equal to `1000`")  # noqa: E501
        if page_size is not None and page_size < 1:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page_size = page_size

    @property
    def limit(self) -> int:
        """Gets the limit of this InstitutionAccountsSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :return: The limit of this InstitutionAccountsSearch.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit: int):
        """Sets the limit of this InstitutionAccountsSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :param limit: The limit of this InstitutionAccountsSearch.
        :type limit: int
        """
        if limit is not None and limit > 1000:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value less than or equal to `1000`")  # noqa: E501
        if limit is not None and limit < 1:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `1`")  # noqa: E501

        self._limit = limit

    @property
    def offset(self) -> int:
        """Gets the offset of this InstitutionAccountsSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :return: The offset of this InstitutionAccountsSearch.
        :rtype: int
        """
        return self._offset

    @offset.setter
    def offset(self, offset: int):
        """Sets the offset of this InstitutionAccountsSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :param offset: The offset of this InstitutionAccountsSearch.
        :type offset: int
        """
        if offset is not None and offset > 5000:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value less than or equal to `5000`")  # noqa: E501
        if offset is not None and offset < 0:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value greater than or equal to `0`")  # noqa: E501

        self._offset = offset

    @property
    def institution_user_id(self) -> str:
        """Gets the institution_user_id of this InstitutionAccountsSearch.

        filter by institution_user_id  # noqa: E501

        :return: The institution_user_id of this InstitutionAccountsSearch.
        :rtype: str
        """
        return self._institution_user_id

    @institution_user_id.setter
    def institution_user_id(self, institution_user_id: str):
        """Sets the institution_user_id of this InstitutionAccountsSearch.

        filter by institution_user_id  # noqa: E501

        :param institution_user_id: The institution_user_id of this InstitutionAccountsSearch.
        :type institution_user_id: str
        """

        self._institution_user_id = institution_user_id

    @property
    def email(self) -> str:
        """Gets the email of this InstitutionAccountsSearch.

        filter by email  # noqa: E501

        :return: The email of this InstitutionAccountsSearch.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email: str):
        """Sets the email of this InstitutionAccountsSearch.

        filter by email  # noqa: E501

        :param email: The email of this InstitutionAccountsSearch.
        :type email: str
        """

        self._email = email
