# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class ItemType(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, name: str=None, string_id: str=None, icon: str=None, public_description: str=None, is_selectable: bool=None, url_name: str=None):  # noqa: E501
        """ItemType - a model defined in Swagger

        :param id: The id of this ItemType.  # noqa: E501
        :type id: int
        :param name: The name of this ItemType.  # noqa: E501
        :type name: str
        :param string_id: The string_id of this ItemType.  # noqa: E501
        :type string_id: str
        :param icon: The icon of this ItemType.  # noqa: E501
        :type icon: str
        :param public_description: The public_description of this ItemType.  # noqa: E501
        :type public_description: str
        :param is_selectable: The is_selectable of this ItemType.  # noqa: E501
        :type is_selectable: bool
        :param url_name: The url_name of this ItemType.  # noqa: E501
        :type url_name: str
        """
        self.swagger_types = {
            'id': int,
            'name': str,
            'string_id': str,
            'icon': str,
            'public_description': str,
            'is_selectable': bool,
            'url_name': str
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'string_id': 'string_id',
            'icon': 'icon',
            'public_description': 'public_description',
            'is_selectable': 'is_selectable',
            'url_name': 'url_name'
        }

        self._id = id
        self._name = name
        self._string_id = string_id
        self._icon = icon
        self._public_description = public_description
        self._is_selectable = is_selectable
        self._url_name = url_name

    @classmethod
    def from_dict(cls, dikt) -> 'ItemType':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ItemType of this ItemType.  # noqa: E501
        :rtype: ItemType
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this ItemType.

        The ID of the item type.  # noqa: E501

        :return: The id of this ItemType.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ItemType.

        The ID of the item type.  # noqa: E501

        :param id: The id of this ItemType.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501
        if id is not None and id < 1:  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def name(self) -> str:
        """Gets the name of this ItemType.

        The name of the item type  # noqa: E501

        :return: The name of this ItemType.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this ItemType.

        The name of the item type  # noqa: E501

        :param name: The name of this ItemType.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def string_id(self) -> str:
        """Gets the string_id of this ItemType.

        The string identifier of the item type.  # noqa: E501

        :return: The string_id of this ItemType.
        :rtype: str
        """
        return self._string_id

    @string_id.setter
    def string_id(self, string_id: str):
        """Sets the string_id of this ItemType.

        The string identifier of the item type.  # noqa: E501

        :param string_id: The string_id of this ItemType.
        :type string_id: str
        """
        if string_id is None:
            raise ValueError("Invalid value for `string_id`, must not be `None`")  # noqa: E501

        self._string_id = string_id

    @property
    def icon(self) -> str:
        """Gets the icon of this ItemType.

        The string identifying the icon of the item type.  # noqa: E501

        :return: The icon of this ItemType.
        :rtype: str
        """
        return self._icon

    @icon.setter
    def icon(self, icon: str):
        """Sets the icon of this ItemType.

        The string identifying the icon of the item type.  # noqa: E501

        :param icon: The icon of this ItemType.
        :type icon: str
        """
        if icon is None:
            raise ValueError("Invalid value for `icon`, must not be `None`")  # noqa: E501

        self._icon = icon

    @property
    def public_description(self) -> str:
        """Gets the public_description of this ItemType.

        The description of the item type.  # noqa: E501

        :return: The public_description of this ItemType.
        :rtype: str
        """
        return self._public_description

    @public_description.setter
    def public_description(self, public_description: str):
        """Sets the public_description of this ItemType.

        The description of the item type.  # noqa: E501

        :param public_description: The public_description of this ItemType.
        :type public_description: str
        """
        if public_description is None:
            raise ValueError("Invalid value for `public_description`, must not be `None`")  # noqa: E501

        self._public_description = public_description

    @property
    def is_selectable(self) -> bool:
        """Gets the is_selectable of this ItemType.

        The selectable status  # noqa: E501

        :return: The is_selectable of this ItemType.
        :rtype: bool
        """
        return self._is_selectable

    @is_selectable.setter
    def is_selectable(self, is_selectable: bool):
        """Sets the is_selectable of this ItemType.

        The selectable status  # noqa: E501

        :param is_selectable: The is_selectable of this ItemType.
        :type is_selectable: bool
        """
        if is_selectable is None:
            raise ValueError("Invalid value for `is_selectable`, must not be `None`")  # noqa: E501

        self._is_selectable = is_selectable

    @property
    def url_name(self) -> str:
        """Gets the url_name of this ItemType.

        The URL name of the item type.  # noqa: E501

        :return: The url_name of this ItemType.
        :rtype: str
        """
        return self._url_name

    @url_name.setter
    def url_name(self, url_name: str):
        """Sets the url_name of this ItemType.

        The URL name of the item type.  # noqa: E501

        :param url_name: The url_name of this ItemType.
        :type url_name: str
        """
        if url_name is None:
            raise ValueError("Invalid value for `url_name`, must not be `None`")  # noqa: E501

        self._url_name = url_name
