# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.article_search import ArticleSearch
from swagger_server import util


class PrivateArticleSearch(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, resource_doi: str=None, item_type: int=None, doi: str=None, handle: str=None, project_id: int=None, order: str='created_date', search_for: str=None, page: int=None, page_size: int=10, limit: int=None, offset: int=None, order_direction: str='desc', institution: int=None, published_since: str=None, modified_since: str=None, group: int=None, resource_id: str=None):  # noqa: E501
        """PrivateArticleSearch - a model defined in Swagger

        :param resource_doi: The resource_doi of this PrivateArticleSearch.  # noqa: E501
        :type resource_doi: str
        :param item_type: The item_type of this PrivateArticleSearch.  # noqa: E501
        :type item_type: int
        :param doi: The doi of this PrivateArticleSearch.  # noqa: E501
        :type doi: str
        :param handle: The handle of this PrivateArticleSearch.  # noqa: E501
        :type handle: str
        :param project_id: The project_id of this PrivateArticleSearch.  # noqa: E501
        :type project_id: int
        :param order: The order of this PrivateArticleSearch.  # noqa: E501
        :type order: str
        :param search_for: The search_for of this PrivateArticleSearch.  # noqa: E501
        :type search_for: str
        :param page: The page of this PrivateArticleSearch.  # noqa: E501
        :type page: int
        :param page_size: The page_size of this PrivateArticleSearch.  # noqa: E501
        :type page_size: int
        :param limit: The limit of this PrivateArticleSearch.  # noqa: E501
        :type limit: int
        :param offset: The offset of this PrivateArticleSearch.  # noqa: E501
        :type offset: int
        :param order_direction: The order_direction of this PrivateArticleSearch.  # noqa: E501
        :type order_direction: str
        :param institution: The institution of this PrivateArticleSearch.  # noqa: E501
        :type institution: int
        :param published_since: The published_since of this PrivateArticleSearch.  # noqa: E501
        :type published_since: str
        :param modified_since: The modified_since of this PrivateArticleSearch.  # noqa: E501
        :type modified_since: str
        :param group: The group of this PrivateArticleSearch.  # noqa: E501
        :type group: int
        :param resource_id: The resource_id of this PrivateArticleSearch.  # noqa: E501
        :type resource_id: str
        """
        self.swagger_types = {
            'resource_doi': str,
            'item_type': int,
            'doi': str,
            'handle': str,
            'project_id': int,
            'order': str,
            'search_for': str,
            'page': int,
            'page_size': int,
            'limit': int,
            'offset': int,
            'order_direction': str,
            'institution': int,
            'published_since': str,
            'modified_since': str,
            'group': int,
            'resource_id': str
        }

        self.attribute_map = {
            'resource_doi': 'resource_doi',
            'item_type': 'item_type',
            'doi': 'doi',
            'handle': 'handle',
            'project_id': 'project_id',
            'order': 'order',
            'search_for': 'search_for',
            'page': 'page',
            'page_size': 'page_size',
            'limit': 'limit',
            'offset': 'offset',
            'order_direction': 'order_direction',
            'institution': 'institution',
            'published_since': 'published_since',
            'modified_since': 'modified_since',
            'group': 'group',
            'resource_id': 'resource_id'
        }

        self._resource_doi = resource_doi
        self._item_type = item_type
        self._doi = doi
        self._handle = handle
        self._project_id = project_id
        self._order = order
        self._search_for = search_for
        self._page = page
        self._page_size = page_size
        self._limit = limit
        self._offset = offset
        self._order_direction = order_direction
        self._institution = institution
        self._published_since = published_since
        self._modified_since = modified_since
        self._group = group
        self._resource_id = resource_id

    @classmethod
    def from_dict(cls, dikt) -> 'PrivateArticleSearch':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The PrivateArticleSearch of this PrivateArticleSearch.  # noqa: E501
        :rtype: PrivateArticleSearch
        """
        return util.deserialize_model(dikt, cls)

    @property
    def resource_doi(self) -> str:
        """Gets the resource_doi of this PrivateArticleSearch.

        Only return articles with this resource_doi  # noqa: E501

        :return: The resource_doi of this PrivateArticleSearch.
        :rtype: str
        """
        return self._resource_doi

    @resource_doi.setter
    def resource_doi(self, resource_doi: str):
        """Sets the resource_doi of this PrivateArticleSearch.

        Only return articles with this resource_doi  # noqa: E501

        :param resource_doi: The resource_doi of this PrivateArticleSearch.
        :type resource_doi: str
        """

        self._resource_doi = resource_doi

    @property
    def item_type(self) -> int:
        """Gets the item_type of this PrivateArticleSearch.

        Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model  # noqa: E501

        :return: The item_type of this PrivateArticleSearch.
        :rtype: int
        """
        return self._item_type

    @item_type.setter
    def item_type(self, item_type: int):
        """Sets the item_type of this PrivateArticleSearch.

        Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model  # noqa: E501

        :param item_type: The item_type of this PrivateArticleSearch.
        :type item_type: int
        """

        self._item_type = item_type

    @property
    def doi(self) -> str:
        """Gets the doi of this PrivateArticleSearch.

        Only return articles with this doi  # noqa: E501

        :return: The doi of this PrivateArticleSearch.
        :rtype: str
        """
        return self._doi

    @doi.setter
    def doi(self, doi: str):
        """Sets the doi of this PrivateArticleSearch.

        Only return articles with this doi  # noqa: E501

        :param doi: The doi of this PrivateArticleSearch.
        :type doi: str
        """

        self._doi = doi

    @property
    def handle(self) -> str:
        """Gets the handle of this PrivateArticleSearch.

        Only return articles with this handle  # noqa: E501

        :return: The handle of this PrivateArticleSearch.
        :rtype: str
        """
        return self._handle

    @handle.setter
    def handle(self, handle: str):
        """Sets the handle of this PrivateArticleSearch.

        Only return articles with this handle  # noqa: E501

        :param handle: The handle of this PrivateArticleSearch.
        :type handle: str
        """

        self._handle = handle

    @property
    def project_id(self) -> int:
        """Gets the project_id of this PrivateArticleSearch.

        Only return articles in this project  # noqa: E501

        :return: The project_id of this PrivateArticleSearch.
        :rtype: int
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id: int):
        """Sets the project_id of this PrivateArticleSearch.

        Only return articles in this project  # noqa: E501

        :param project_id: The project_id of this PrivateArticleSearch.
        :type project_id: int
        """

        self._project_id = project_id

    @property
    def order(self) -> str:
        """Gets the order of this PrivateArticleSearch.

        The field by which to order  # noqa: E501

        :return: The order of this PrivateArticleSearch.
        :rtype: str
        """
        return self._order

    @order.setter
    def order(self, order: str):
        """Sets the order of this PrivateArticleSearch.

        The field by which to order  # noqa: E501

        :param order: The order of this PrivateArticleSearch.
        :type order: str
        """
        allowed_values = ["created_date", "published_date", "modified_date", "views", "shares", "downloads", "cites"]  # noqa: E501
        if order not in allowed_values:
            raise ValueError(
                "Invalid value for `order` ({0}), must be one of {1}"
                .format(order, allowed_values)
            )

        self._order = order

    @property
    def search_for(self) -> str:
        """Gets the search_for of this PrivateArticleSearch.

        Search term  # noqa: E501

        :return: The search_for of this PrivateArticleSearch.
        :rtype: str
        """
        return self._search_for

    @search_for.setter
    def search_for(self, search_for: str):
        """Sets the search_for of this PrivateArticleSearch.

        Search term  # noqa: E501

        :param search_for: The search_for of this PrivateArticleSearch.
        :type search_for: str
        """

        self._search_for = search_for

    @property
    def page(self) -> int:
        """Gets the page of this PrivateArticleSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :return: The page of this PrivateArticleSearch.
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page: int):
        """Sets the page of this PrivateArticleSearch.

        Page number. Used for pagination with page_size  # noqa: E501

        :param page: The page of this PrivateArticleSearch.
        :type page: int
        """
        if page is not None and page > 5000:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value less than or equal to `5000`")  # noqa: E501
        if page is not None and page < 1:  # noqa: E501
            raise ValueError("Invalid value for `page`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page = page

    @property
    def page_size(self) -> int:
        """Gets the page_size of this PrivateArticleSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :return: The page_size of this PrivateArticleSearch.
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size: int):
        """Sets the page_size of this PrivateArticleSearch.

        The number of results included on a page. Used for pagination with page  # noqa: E501

        :param page_size: The page_size of this PrivateArticleSearch.
        :type page_size: int
        """
        if page_size is not None and page_size > 1000:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value less than or equal to `1000`")  # noqa: E501
        if page_size is not None and page_size < 1:  # noqa: E501
            raise ValueError("Invalid value for `page_size`, must be a value greater than or equal to `1`")  # noqa: E501

        self._page_size = page_size

    @property
    def limit(self) -> int:
        """Gets the limit of this PrivateArticleSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :return: The limit of this PrivateArticleSearch.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit: int):
        """Sets the limit of this PrivateArticleSearch.

        Number of results included on a page. Used for pagination with query  # noqa: E501

        :param limit: The limit of this PrivateArticleSearch.
        :type limit: int
        """
        if limit is not None and limit > 1000:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value less than or equal to `1000`")  # noqa: E501
        if limit is not None and limit < 1:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `1`")  # noqa: E501

        self._limit = limit

    @property
    def offset(self) -> int:
        """Gets the offset of this PrivateArticleSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :return: The offset of this PrivateArticleSearch.
        :rtype: int
        """
        return self._offset

    @offset.setter
    def offset(self, offset: int):
        """Sets the offset of this PrivateArticleSearch.

        Where to start the listing(the offset of the first result). Used for pagination with limit  # noqa: E501

        :param offset: The offset of this PrivateArticleSearch.
        :type offset: int
        """
        if offset is not None and offset > 5000:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value less than or equal to `5000`")  # noqa: E501
        if offset is not None and offset < 0:  # noqa: E501
            raise ValueError("Invalid value for `offset`, must be a value greater than or equal to `0`")  # noqa: E501

        self._offset = offset

    @property
    def order_direction(self) -> str:
        """Gets the order_direction of this PrivateArticleSearch.

        Direction of ordering  # noqa: E501

        :return: The order_direction of this PrivateArticleSearch.
        :rtype: str
        """
        return self._order_direction

    @order_direction.setter
    def order_direction(self, order_direction: str):
        """Sets the order_direction of this PrivateArticleSearch.

        Direction of ordering  # noqa: E501

        :param order_direction: The order_direction of this PrivateArticleSearch.
        :type order_direction: str
        """
        allowed_values = ["asc", "desc"]  # noqa: E501
        if order_direction not in allowed_values:
            raise ValueError(
                "Invalid value for `order_direction` ({0}), must be one of {1}"
                .format(order_direction, allowed_values)
            )

        self._order_direction = order_direction

    @property
    def institution(self) -> int:
        """Gets the institution of this PrivateArticleSearch.

        only return collections from this institution  # noqa: E501

        :return: The institution of this PrivateArticleSearch.
        :rtype: int
        """
        return self._institution

    @institution.setter
    def institution(self, institution: int):
        """Sets the institution of this PrivateArticleSearch.

        only return collections from this institution  # noqa: E501

        :param institution: The institution of this PrivateArticleSearch.
        :type institution: int
        """

        self._institution = institution

    @property
    def published_since(self) -> str:
        """Gets the published_since of this PrivateArticleSearch.

        Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :return: The published_since of this PrivateArticleSearch.
        :rtype: str
        """
        return self._published_since

    @published_since.setter
    def published_since(self, published_since: str):
        """Sets the published_since of this PrivateArticleSearch.

        Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :param published_since: The published_since of this PrivateArticleSearch.
        :type published_since: str
        """

        self._published_since = published_since

    @property
    def modified_since(self) -> str:
        """Gets the modified_since of this PrivateArticleSearch.

        Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :return: The modified_since of this PrivateArticleSearch.
        :rtype: str
        """
        return self._modified_since

    @modified_since.setter
    def modified_since(self, modified_since: str):
        """Sets the modified_since of this PrivateArticleSearch.

        Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD  # noqa: E501

        :param modified_since: The modified_since of this PrivateArticleSearch.
        :type modified_since: str
        """

        self._modified_since = modified_since

    @property
    def group(self) -> int:
        """Gets the group of this PrivateArticleSearch.

        only return collections from this group  # noqa: E501

        :return: The group of this PrivateArticleSearch.
        :rtype: int
        """
        return self._group

    @group.setter
    def group(self, group: int):
        """Sets the group of this PrivateArticleSearch.

        only return collections from this group  # noqa: E501

        :param group: The group of this PrivateArticleSearch.
        :type group: int
        """

        self._group = group

    @property
    def resource_id(self) -> str:
        """Gets the resource_id of this PrivateArticleSearch.

        only return collections with this resource_id  # noqa: E501

        :return: The resource_id of this PrivateArticleSearch.
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id: str):
        """Sets the resource_id of this PrivateArticleSearch.

        only return collections with this resource_id  # noqa: E501

        :param resource_id: The resource_id of this PrivateArticleSearch.
        :type resource_id: str
        """

        self._resource_id = resource_id
