# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.collaborator import Collaborator
from swagger_server.models.funding_information import FundingInformation
from swagger_server.models.project import Project
from swagger_server import util


class ProjectComplete(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, url: str=None, id: int=None, title: str=None, funding: str=None, funding_list: List[FundingInformation]=None, description: str=None, collaborators: List[Collaborator]=None):  # noqa: E501
        """ProjectComplete - a model defined in Swagger

        :param url: The url of this ProjectComplete.  # noqa: E501
        :type url: str
        :param id: The id of this ProjectComplete.  # noqa: E501
        :type id: int
        :param title: The title of this ProjectComplete.  # noqa: E501
        :type title: str
        :param funding: The funding of this ProjectComplete.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this ProjectComplete.  # noqa: E501
        :type funding_list: List[FundingInformation]
        :param description: The description of this ProjectComplete.  # noqa: E501
        :type description: str
        :param collaborators: The collaborators of this ProjectComplete.  # noqa: E501
        :type collaborators: List[Collaborator]
        """
        self.swagger_types = {
            'url': str,
            'id': int,
            'title': str,
            'funding': str,
            'funding_list': List[FundingInformation],
            'description': str,
            'collaborators': List[Collaborator]
        }

        self.attribute_map = {
            'url': 'url',
            'id': 'id',
            'title': 'title',
            'funding': 'funding',
            'funding_list': 'funding_list',
            'description': 'description',
            'collaborators': 'collaborators'
        }

        self._url = url
        self._id = id
        self._title = title
        self._funding = funding
        self._funding_list = funding_list
        self._description = description
        self._collaborators = collaborators

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectComplete':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectComplete of this ProjectComplete.  # noqa: E501
        :rtype: ProjectComplete
        """
        return util.deserialize_model(dikt, cls)

    @property
    def url(self) -> str:
        """Gets the url of this ProjectComplete.

        Api endpoint  # noqa: E501

        :return: The url of this ProjectComplete.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this ProjectComplete.

        Api endpoint  # noqa: E501

        :param url: The url of this ProjectComplete.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def id(self) -> int:
        """Gets the id of this ProjectComplete.

        Project id  # noqa: E501

        :return: The id of this ProjectComplete.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ProjectComplete.

        Project id  # noqa: E501

        :param id: The id of this ProjectComplete.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this ProjectComplete.

        Project title  # noqa: E501

        :return: The title of this ProjectComplete.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ProjectComplete.

        Project title  # noqa: E501

        :param title: The title of this ProjectComplete.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def funding(self) -> str:
        """Gets the funding of this ProjectComplete.

        Project funding  # noqa: E501

        :return: The funding of this ProjectComplete.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this ProjectComplete.

        Project funding  # noqa: E501

        :param funding: The funding of this ProjectComplete.
        :type funding: str
        """
        if funding is None:
            raise ValueError("Invalid value for `funding`, must not be `None`")  # noqa: E501

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingInformation]:
        """Gets the funding_list of this ProjectComplete.

        Full Project funding information  # noqa: E501

        :return: The funding_list of this ProjectComplete.
        :rtype: List[FundingInformation]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingInformation]):
        """Sets the funding_list of this ProjectComplete.

        Full Project funding information  # noqa: E501

        :param funding_list: The funding_list of this ProjectComplete.
        :type funding_list: List[FundingInformation]
        """
        if funding_list is None:
            raise ValueError("Invalid value for `funding_list`, must not be `None`")  # noqa: E501

        self._funding_list = funding_list

    @property
    def description(self) -> str:
        """Gets the description of this ProjectComplete.

        Project description  # noqa: E501

        :return: The description of this ProjectComplete.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this ProjectComplete.

        Project description  # noqa: E501

        :param description: The description of this ProjectComplete.
        :type description: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def collaborators(self) -> List[Collaborator]:
        """Gets the collaborators of this ProjectComplete.

        List of project collaborators  # noqa: E501

        :return: The collaborators of this ProjectComplete.
        :rtype: List[Collaborator]
        """
        return self._collaborators

    @collaborators.setter
    def collaborators(self, collaborators: List[Collaborator]):
        """Sets the collaborators of this ProjectComplete.

        List of project collaborators  # noqa: E501

        :param collaborators: The collaborators of this ProjectComplete.
        :type collaborators: List[Collaborator]
        """
        if collaborators is None:
            raise ValueError("Invalid value for `collaborators`, must not be `None`")  # noqa: E501

        self._collaborators = collaborators
