# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.collaborator import Collaborator
from swagger_server.models.custom_article_field import CustomArticleField
from swagger_server.models.funding_information import FundingInformation
from swagger_server.models.project_private import ProjectPrivate
from swagger_server import util


class ProjectCompletePrivate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, role: str=None, storage: str=None, url: str=None, id: int=None, title: str=None, funding: str=None, funding_list: List[FundingInformation]=None, description: str=None, collaborators: List[Collaborator]=None, quota: int=None, used_quota: int=None, created_date: str=None, modified_date: str=None, used_quota_private: int=None, used_quota_public: int=None, group_id: int=None, account_id: int=None, custom_fields: List[CustomArticleField]=None):  # noqa: E501
        """ProjectCompletePrivate - a model defined in Swagger

        :param role: The role of this ProjectCompletePrivate.  # noqa: E501
        :type role: str
        :param storage: The storage of this ProjectCompletePrivate.  # noqa: E501
        :type storage: str
        :param url: The url of this ProjectCompletePrivate.  # noqa: E501
        :type url: str
        :param id: The id of this ProjectCompletePrivate.  # noqa: E501
        :type id: int
        :param title: The title of this ProjectCompletePrivate.  # noqa: E501
        :type title: str
        :param funding: The funding of this ProjectCompletePrivate.  # noqa: E501
        :type funding: str
        :param funding_list: The funding_list of this ProjectCompletePrivate.  # noqa: E501
        :type funding_list: List[FundingInformation]
        :param description: The description of this ProjectCompletePrivate.  # noqa: E501
        :type description: str
        :param collaborators: The collaborators of this ProjectCompletePrivate.  # noqa: E501
        :type collaborators: List[Collaborator]
        :param quota: The quota of this ProjectCompletePrivate.  # noqa: E501
        :type quota: int
        :param used_quota: The used_quota of this ProjectCompletePrivate.  # noqa: E501
        :type used_quota: int
        :param created_date: The created_date of this ProjectCompletePrivate.  # noqa: E501
        :type created_date: str
        :param modified_date: The modified_date of this ProjectCompletePrivate.  # noqa: E501
        :type modified_date: str
        :param used_quota_private: The used_quota_private of this ProjectCompletePrivate.  # noqa: E501
        :type used_quota_private: int
        :param used_quota_public: The used_quota_public of this ProjectCompletePrivate.  # noqa: E501
        :type used_quota_public: int
        :param group_id: The group_id of this ProjectCompletePrivate.  # noqa: E501
        :type group_id: int
        :param account_id: The account_id of this ProjectCompletePrivate.  # noqa: E501
        :type account_id: int
        :param custom_fields: The custom_fields of this ProjectCompletePrivate.  # noqa: E501
        :type custom_fields: List[CustomArticleField]
        """
        self.swagger_types = {
            'role': str,
            'storage': str,
            'url': str,
            'id': int,
            'title': str,
            'funding': str,
            'funding_list': List[FundingInformation],
            'description': str,
            'collaborators': List[Collaborator],
            'quota': int,
            'used_quota': int,
            'created_date': str,
            'modified_date': str,
            'used_quota_private': int,
            'used_quota_public': int,
            'group_id': int,
            'account_id': int,
            'custom_fields': List[CustomArticleField]
        }

        self.attribute_map = {
            'role': 'role',
            'storage': 'storage',
            'url': 'url',
            'id': 'id',
            'title': 'title',
            'funding': 'funding',
            'funding_list': 'funding_list',
            'description': 'description',
            'collaborators': 'collaborators',
            'quota': 'quota',
            'used_quota': 'used_quota',
            'created_date': 'created_date',
            'modified_date': 'modified_date',
            'used_quota_private': 'used_quota_private',
            'used_quota_public': 'used_quota_public',
            'group_id': 'group_id',
            'account_id': 'account_id',
            'custom_fields': 'custom_fields'
        }

        self._role = role
        self._storage = storage
        self._url = url
        self._id = id
        self._title = title
        self._funding = funding
        self._funding_list = funding_list
        self._description = description
        self._collaborators = collaborators
        self._quota = quota
        self._used_quota = used_quota
        self._created_date = created_date
        self._modified_date = modified_date
        self._used_quota_private = used_quota_private
        self._used_quota_public = used_quota_public
        self._group_id = group_id
        self._account_id = account_id
        self._custom_fields = custom_fields

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectCompletePrivate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectCompletePrivate of this ProjectCompletePrivate.  # noqa: E501
        :rtype: ProjectCompletePrivate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def role(self) -> str:
        """Gets the role of this ProjectCompletePrivate.

        Role inside this project  # noqa: E501

        :return: The role of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role: str):
        """Sets the role of this ProjectCompletePrivate.

        Role inside this project  # noqa: E501

        :param role: The role of this ProjectCompletePrivate.
        :type role: str
        """
        allowed_values = ["Owner", "Collaborator", "Viewer"]  # noqa: E501
        if role not in allowed_values:
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def storage(self) -> str:
        """Gets the storage of this ProjectCompletePrivate.

        Project storage type  # noqa: E501

        :return: The storage of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._storage

    @storage.setter
    def storage(self, storage: str):
        """Sets the storage of this ProjectCompletePrivate.

        Project storage type  # noqa: E501

        :param storage: The storage of this ProjectCompletePrivate.
        :type storage: str
        """
        allowed_values = ["individual", "group"]  # noqa: E501
        if storage not in allowed_values:
            raise ValueError(
                "Invalid value for `storage` ({0}), must be one of {1}"
                .format(storage, allowed_values)
            )

        self._storage = storage

    @property
    def url(self) -> str:
        """Gets the url of this ProjectCompletePrivate.

        Api endpoint  # noqa: E501

        :return: The url of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this ProjectCompletePrivate.

        Api endpoint  # noqa: E501

        :param url: The url of this ProjectCompletePrivate.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def id(self) -> int:
        """Gets the id of this ProjectCompletePrivate.

        Project id  # noqa: E501

        :return: The id of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ProjectCompletePrivate.

        Project id  # noqa: E501

        :param id: The id of this ProjectCompletePrivate.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this ProjectCompletePrivate.

        Project title  # noqa: E501

        :return: The title of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ProjectCompletePrivate.

        Project title  # noqa: E501

        :param title: The title of this ProjectCompletePrivate.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def funding(self) -> str:
        """Gets the funding of this ProjectCompletePrivate.

        Project funding  # noqa: E501

        :return: The funding of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._funding

    @funding.setter
    def funding(self, funding: str):
        """Sets the funding of this ProjectCompletePrivate.

        Project funding  # noqa: E501

        :param funding: The funding of this ProjectCompletePrivate.
        :type funding: str
        """
        if funding is None:
            raise ValueError("Invalid value for `funding`, must not be `None`")  # noqa: E501

        self._funding = funding

    @property
    def funding_list(self) -> List[FundingInformation]:
        """Gets the funding_list of this ProjectCompletePrivate.

        Full Project funding information  # noqa: E501

        :return: The funding_list of this ProjectCompletePrivate.
        :rtype: List[FundingInformation]
        """
        return self._funding_list

    @funding_list.setter
    def funding_list(self, funding_list: List[FundingInformation]):
        """Sets the funding_list of this ProjectCompletePrivate.

        Full Project funding information  # noqa: E501

        :param funding_list: The funding_list of this ProjectCompletePrivate.
        :type funding_list: List[FundingInformation]
        """
        if funding_list is None:
            raise ValueError("Invalid value for `funding_list`, must not be `None`")  # noqa: E501

        self._funding_list = funding_list

    @property
    def description(self) -> str:
        """Gets the description of this ProjectCompletePrivate.

        Project description  # noqa: E501

        :return: The description of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str):
        """Sets the description of this ProjectCompletePrivate.

        Project description  # noqa: E501

        :param description: The description of this ProjectCompletePrivate.
        :type description: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def collaborators(self) -> List[Collaborator]:
        """Gets the collaborators of this ProjectCompletePrivate.

        List of project collaborators  # noqa: E501

        :return: The collaborators of this ProjectCompletePrivate.
        :rtype: List[Collaborator]
        """
        return self._collaborators

    @collaborators.setter
    def collaborators(self, collaborators: List[Collaborator]):
        """Sets the collaborators of this ProjectCompletePrivate.

        List of project collaborators  # noqa: E501

        :param collaborators: The collaborators of this ProjectCompletePrivate.
        :type collaborators: List[Collaborator]
        """
        if collaborators is None:
            raise ValueError("Invalid value for `collaborators`, must not be `None`")  # noqa: E501

        self._collaborators = collaborators

    @property
    def quota(self) -> int:
        """Gets the quota of this ProjectCompletePrivate.

        Project quota  # noqa: E501

        :return: The quota of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._quota

    @quota.setter
    def quota(self, quota: int):
        """Sets the quota of this ProjectCompletePrivate.

        Project quota  # noqa: E501

        :param quota: The quota of this ProjectCompletePrivate.
        :type quota: int
        """
        if quota is None:
            raise ValueError("Invalid value for `quota`, must not be `None`")  # noqa: E501

        self._quota = quota

    @property
    def used_quota(self) -> int:
        """Gets the used_quota of this ProjectCompletePrivate.

        Project used quota  # noqa: E501

        :return: The used_quota of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._used_quota

    @used_quota.setter
    def used_quota(self, used_quota: int):
        """Sets the used_quota of this ProjectCompletePrivate.

        Project used quota  # noqa: E501

        :param used_quota: The used_quota of this ProjectCompletePrivate.
        :type used_quota: int
        """
        if used_quota is None:
            raise ValueError("Invalid value for `used_quota`, must not be `None`")  # noqa: E501

        self._used_quota = used_quota

    @property
    def created_date(self) -> str:
        """Gets the created_date of this ProjectCompletePrivate.

        Date when project was created  # noqa: E501

        :return: The created_date of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date: str):
        """Sets the created_date of this ProjectCompletePrivate.

        Date when project was created  # noqa: E501

        :param created_date: The created_date of this ProjectCompletePrivate.
        :type created_date: str
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    @property
    def modified_date(self) -> str:
        """Gets the modified_date of this ProjectCompletePrivate.

        Date when project was last modified  # noqa: E501

        :return: The modified_date of this ProjectCompletePrivate.
        :rtype: str
        """
        return self._modified_date

    @modified_date.setter
    def modified_date(self, modified_date: str):
        """Sets the modified_date of this ProjectCompletePrivate.

        Date when project was last modified  # noqa: E501

        :param modified_date: The modified_date of this ProjectCompletePrivate.
        :type modified_date: str
        """
        if modified_date is None:
            raise ValueError("Invalid value for `modified_date`, must not be `None`")  # noqa: E501

        self._modified_date = modified_date

    @property
    def used_quota_private(self) -> int:
        """Gets the used_quota_private of this ProjectCompletePrivate.

        Project private quota used  # noqa: E501

        :return: The used_quota_private of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._used_quota_private

    @used_quota_private.setter
    def used_quota_private(self, used_quota_private: int):
        """Sets the used_quota_private of this ProjectCompletePrivate.

        Project private quota used  # noqa: E501

        :param used_quota_private: The used_quota_private of this ProjectCompletePrivate.
        :type used_quota_private: int
        """
        if used_quota_private is None:
            raise ValueError("Invalid value for `used_quota_private`, must not be `None`")  # noqa: E501

        self._used_quota_private = used_quota_private

    @property
    def used_quota_public(self) -> int:
        """Gets the used_quota_public of this ProjectCompletePrivate.

        Project public quota used  # noqa: E501

        :return: The used_quota_public of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._used_quota_public

    @used_quota_public.setter
    def used_quota_public(self, used_quota_public: int):
        """Sets the used_quota_public of this ProjectCompletePrivate.

        Project public quota used  # noqa: E501

        :param used_quota_public: The used_quota_public of this ProjectCompletePrivate.
        :type used_quota_public: int
        """
        if used_quota_public is None:
            raise ValueError("Invalid value for `used_quota_public`, must not be `None`")  # noqa: E501

        self._used_quota_public = used_quota_public

    @property
    def group_id(self) -> int:
        """Gets the group_id of this ProjectCompletePrivate.

        Group of project if any  # noqa: E501

        :return: The group_id of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id: int):
        """Sets the group_id of this ProjectCompletePrivate.

        Group of project if any  # noqa: E501

        :param group_id: The group_id of this ProjectCompletePrivate.
        :type group_id: int
        """
        if group_id is None:
            raise ValueError("Invalid value for `group_id`, must not be `None`")  # noqa: E501

        self._group_id = group_id

    @property
    def account_id(self) -> int:
        """Gets the account_id of this ProjectCompletePrivate.

        ID of the account owning the project  # noqa: E501

        :return: The account_id of this ProjectCompletePrivate.
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id: int):
        """Sets the account_id of this ProjectCompletePrivate.

        ID of the account owning the project  # noqa: E501

        :param account_id: The account_id of this ProjectCompletePrivate.
        :type account_id: int
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def custom_fields(self) -> List[CustomArticleField]:
        """Gets the custom_fields of this ProjectCompletePrivate.

        Collection custom fields  # noqa: E501

        :return: The custom_fields of this ProjectCompletePrivate.
        :rtype: List[CustomArticleField]
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields: List[CustomArticleField]):
        """Sets the custom_fields of this ProjectCompletePrivate.

        Collection custom fields  # noqa: E501

        :param custom_fields: The custom_fields of this ProjectCompletePrivate.
        :type custom_fields: List[CustomArticleField]
        """
        if custom_fields is None:
            raise ValueError("Invalid value for `custom_fields`, must not be `None`")  # noqa: E501

        self._custom_fields = custom_fields
