# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.project import Project
from swagger_server import util


class ProjectPrivate(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, url: str=None, id: int=None, title: str=None, role: str=None, storage: str=None):  # noqa: E501
        """ProjectPrivate - a model defined in Swagger

        :param url: The url of this ProjectPrivate.  # noqa: E501
        :type url: str
        :param id: The id of this ProjectPrivate.  # noqa: E501
        :type id: int
        :param title: The title of this ProjectPrivate.  # noqa: E501
        :type title: str
        :param role: The role of this ProjectPrivate.  # noqa: E501
        :type role: str
        :param storage: The storage of this ProjectPrivate.  # noqa: E501
        :type storage: str
        """
        self.swagger_types = {
            'url': str,
            'id': int,
            'title': str,
            'role': str,
            'storage': str
        }

        self.attribute_map = {
            'url': 'url',
            'id': 'id',
            'title': 'title',
            'role': 'role',
            'storage': 'storage'
        }

        self._url = url
        self._id = id
        self._title = title
        self._role = role
        self._storage = storage

    @classmethod
    def from_dict(cls, dikt) -> 'ProjectPrivate':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ProjectPrivate of this ProjectPrivate.  # noqa: E501
        :rtype: ProjectPrivate
        """
        return util.deserialize_model(dikt, cls)

    @property
    def url(self) -> str:
        """Gets the url of this ProjectPrivate.

        Api endpoint  # noqa: E501

        :return: The url of this ProjectPrivate.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url: str):
        """Sets the url of this ProjectPrivate.

        Api endpoint  # noqa: E501

        :param url: The url of this ProjectPrivate.
        :type url: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def id(self) -> int:
        """Gets the id of this ProjectPrivate.

        Project id  # noqa: E501

        :return: The id of this ProjectPrivate.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this ProjectPrivate.

        Project id  # noqa: E501

        :param id: The id of this ProjectPrivate.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self) -> str:
        """Gets the title of this ProjectPrivate.

        Project title  # noqa: E501

        :return: The title of this ProjectPrivate.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ProjectPrivate.

        Project title  # noqa: E501

        :param title: The title of this ProjectPrivate.
        :type title: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def role(self) -> str:
        """Gets the role of this ProjectPrivate.

        Role inside this project  # noqa: E501

        :return: The role of this ProjectPrivate.
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role: str):
        """Sets the role of this ProjectPrivate.

        Role inside this project  # noqa: E501

        :param role: The role of this ProjectPrivate.
        :type role: str
        """
        allowed_values = ["Owner", "Collaborator", "Viewer"]  # noqa: E501
        if role not in allowed_values:
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def storage(self) -> str:
        """Gets the storage of this ProjectPrivate.

        Project storage type  # noqa: E501

        :return: The storage of this ProjectPrivate.
        :rtype: str
        """
        return self._storage

    @storage.setter
    def storage(self, storage: str):
        """Sets the storage of this ProjectPrivate.

        Project storage type  # noqa: E501

        :param storage: The storage of this ProjectPrivate.
        :type storage: str
        """
        allowed_values = ["individual", "group"]  # noqa: E501
        if storage not in allowed_values:
            raise ValueError(
                "Invalid value for `storage` ({0}), must be one of {1}"
                .format(storage, allowed_values)
            )

        self._storage = storage
