# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from swagger_server.models.account import Account  # noqa: E501
from swagger_server.models.category import Category  # noqa: E501
from swagger_server.models.error_message import ErrorMessage  # noqa: E501
from swagger_server.models.funding_information import FundingInformation  # noqa: E501
from swagger_server.models.funding_search import FundingSearch  # noqa: E501
from swagger_server.models.item_type import ItemType  # noqa: E501
from swagger_server.models.license import License  # noqa: E501
from swagger_server.test import BaseTestCase


class TestOtherController(BaseTestCase):
    """OtherController integration test stubs"""

    def test_categories_list(self):
        """Test case for categories_list

        Public Categories
        """
        response = self.client.open(
            '/v2/categories',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_file_download(self):
        """Test case for file_download

        Public File Download
        """
        response = self.client.open(
            '/v2/file/download/{file_id}'.format(file_id=2),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_item_types_list(self):
        """Test case for item_types_list

        Item Types
        """
        query_string = [('group_id', 1)]
        response = self.client.open(
            '/v2/item_types',
            method='GET',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_licenses_list(self):
        """Test case for licenses_list

        Public Licenses
        """
        response = self.client.open(
            '/v2/licenses',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_private_account(self):
        """Test case for private_account

        Private Account information
        """
        response = self.client.open(
            '/v2/account',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_private_funding_search(self):
        """Test case for private_funding_search

        Search Funding
        """
        search = FundingSearch()
        response = self.client.open(
            '/v2/account/funding/search',
            method='POST',
            data=json.dumps(search),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_private_licenses_list(self):
        """Test case for private_licenses_list

        Private Account Licenses
        """
        response = self.client.open(
            '/v2/account/licenses',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
